import { PromiseTypedObjectOrArray, PromiseObjectOrArray } from "../interfaces";

interface First {
    /**
     * Takes multiple promises and returns a new promise that is fulfilled
     * when the first of these promises is fulfilled.
     * @param objectOrArray The promises are taken from the array or object values. If no value
     * 						is passed, the returned promise is resolved with an undefined value.
     */
    <T>(objectOrArray?: PromiseTypedObjectOrArray<T>): Promise<T>;
    (objectOrArray?: PromiseObjectOrArray): Promise<any>;
}

declare const First: First;
export = First;
